---
title: Contributing to Taskwarrior
---

Help is needed in all areas of Taskwarrior development - design, coding, testing, support and marketing.
Applicants must be friendly.
Perhaps you are looking to help, but don't know where to start.
You can of course [email us](mailto:taskwarrior-dev@googlegroups.com) but take a look at this list.
Perhaps you have skills we are looking for, here are ways you may be able to help:

-   Use Taskwarrior, become familiar with it, and make suggestions.
    We get great feedback from both new users and veteran users.
    New users have a fresh approach that we can no longer achieve, while veteran users develop clever and crafty ways to use the product.

-   Report bugs and odd behavior when you see it.
    We don't necessarily know it's broken, unless you tell us.

-   Suggest enhancements.
    We get lots of these, and it's great.
    Some really good ideas have been suggested and implemented.
    Sure, some are out of scope, or plain crazy, but the stream of suggestions is fascinating to think about.

-   Participate in the [bug tracking](https://github.com/GothenburgBitFactory/taskwarrior/issues) database, to help others and maybe learn something yourself.

-   Help [triage](/docs/triage) the issues list.

-   Join the IRC channel \#taskwarrior on freenode.net and help answer some questions.

-   Join either the [developer-mailinglist](https://groups.google.com/forum/#!forum/taskwarrior-dev) or [user-mailinglist](https://groups.google.com/forum/#!forum/taskwarrior-user) (or both) and participate.

-   Proofread the documentation and man pages.

-   Improve the documentation.

-   Improve the man pages.

-   Help improve the tutorials.
    Make your own tutorial.

-   Confirm a bug.
    Nothing gets fixed without confirmation.

-   Refine a bug.
    Provide relevant details, elaborate on the behavior.

-   Fix a bug.
    Send a patch.
    You'll need C++ skills for this.

-   Write a unit test.
    Improve an existing unit test.

-   Spread the word.
    Help others become more effective at managing tasks.
    Share your methodology, to inspire others.

-   Encouragement.
    Tell us what works for you, and what doesn't.
    It's all good.

-   Donate! Help offset costs.

Please remember that we need contributions from all skillsets, however small.
Every contribution helps.
