---
title: Taskwarrior Development Documentation
---

This site contains the _development_ documentation for Taskwarrior.
For all other documenation, see https://taskwarrior.org.

## Contributing to Taskwarrior

 * [How to become an Open Source Contributor](./contrib/first_time.md)
 * [Contributing to Taskwarrior](./contrib/contribute.md)
 * [Developing Taskwarrior](./contrib/development.md)
 * [Building Taskwarrior](./contrib/build.md)
 * [Coding Style](./contrib/coding_style.md)
 * [Branching Model](./contrib/branching.md)
 * [Rust and C++](./contrib/rust-and-c++.md)

## RFC's

This is where design documents (RFCs) are kept.

Although these documents are less formal than [IETF RFCs](https://www.ietf.org/rfc) they serve a similar purpose.
These documents apply only to the Taskwarrior family of products, and are placed here to invite comment before designs finalize.

 -   [General Plans](./rfcs/plans.md)
 -   [Rules System](./rfcs/rules.md)
 -   [Full DOM Support ](./rfcs/dom.md)
 -   [Work Week Support](./rfcs/workweek.md)
 -   [Recurrence](./rfcs/recurrence.md)
 -   [Taskwarrior JSON Format](./rfcs/task.md)
 -   [CLI Updates ](./rfcs/cli.md)
 -   [Taskserver Sync Protocol](./rfcs/protocol.md)
 -   [Taskserver Message Format](./rfcs/request.md)
 -   [Taskserver Sync Algorithm](./rfcs/sync.md)
 -   [Taskserver Client](./rfcs/client.md)
